## Bo(keh) Selecta! (c) 2019 Chris Glew Ltd.
## v03.00.01 - builds icon paths with any OS
## v03.01.00 - copies bokeh asset to nuke scene folder
## v03.01.05 - uses local version of bokeh asset if nukescript not saved

import nuke
import os
from os.path import expanduser
import sys
import shutil

try:
    nuke.NUKE_VERSION_MAJOR < 11
    import PySide.QtGui as QtGui
except:
    nuke.NUKE_VERSION_MAJOR >= 11
    import PySide2.QtWidgets as QtGui

def bokehSelecta3():

  clipboard = QtGui.QApplication.clipboard()
  home = expanduser("~")
  OpSys = str(sys.platform)
  linBased = ['linux1', 'linux2', 'darwin']

  if OpSys in linBased:
      home = home.replace ( '\\' , '/' )
      nukeDir = ("/.nuke/python/bokehIcons/")
      slashOs = '/'
  else:
      home = home.replace ( '/' , '\\' )
      nukeDir = ("\\.nuke\\python\\bokehIcons\\")
      slashOs = '\\'

  bokR = home+nukeDir
  bokM = bokR+'bokeh.png'
  e = nuke.root().name()
  bokNet = os.path.dirname(e)+slashOs+'bokeh.png'

  if bokNet == str(slashOs+'bokeh.png'):
    bokNet = bokM
    nuke.message('Project (probably) not saved on network. Using local version of bokeh asset. Run script again once Nuke Script saved to fix')

  p = os.path.isfile(bokNet)
  try:
    if p == False:
      shutil.copy(bokM, bokNet)
      nuke.message('bokeh asset copied to nuke file directory')
  except:
    pass

  bokeh_a = '"<img src=\\"'+bokR+'bokeh_a.png\\">"'
  bokeh_b = '"<img src=\\"'+bokR+'bokeh_b.png\\">"'
  bokeh_c = '"<img src=\\"'+bokR+'bokeh_c.png\\">"'
  bokeh_d = '"<img src=\\"'+bokR+'bokeh_d.png\\">"'
  bokeh_e = '"<img src=\\"'+bokR+'bokeh_e.png\\">"'
  bokeh_f = '"<img src=\\"'+bokR+'bokeh_f.png\\">"'
  bokeh_g = '"<img src=\\"'+bokR+'bokeh_g.png\\">"'
  bokeh_h = '"<img src=\\"'+bokR+'bokeh_h.png\\">"'
  bokeh_i = '"<img src=\\"'+bokR+'bokeh_i.png\\">"'
  bokeh_k = '"<img src=\\"'+bokR+'bokeh_k.png\\">"'
  bokeh_l = '"<img src=\\"'+bokR+'bokeh_l.png\\">"'

  nothZ = '""'
  scaleZ = '"Scale the shape Kernel"'
  shapeZ = '"Chose from the various Bokeh Shapes from the dropdown list"'
  glewZ = '"Bo(keh) Selecta! (c) 2019 Chris Glew Ltd."'
  formZ = '"925 618 0 0 925 618 1 "'

  bokSel = "Group {\n inputs 0\n name Bokeh_Selecta\n selected true\n addUserKnob {20 User}\n addUserKnob {22 imgButton1 l "+bokeh_a+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(0)}\n addUserKnob {22 imgButton2 l "+bokeh_b+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(1)}\n addUserKnob {22 imgButton3 l "+bokeh_c+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(2)}\n addUserKnob {22 imgButton4 l "+bokeh_d+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(3)}\n addUserKnob {22 imgButton5 l "+bokeh_e+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(4)}\n addUserKnob {22 imgButton6 l "+bokeh_f+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(5)}\n addUserKnob {22 imgButton7 l "+bokeh_g+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(6)}\n addUserKnob {22 imgButton8 l "+bokeh_h+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(7)}\n addUserKnob {22 imgButton9 l "+bokeh_i+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(8)}\n addUserKnob {22 imgButton10 l "+bokeh_k+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(10)}\n addUserKnob {22 imgButton11 l "+bokeh_l+" -STARTLINE T nuke.thisNode().knob('Choose_Shape').setValue(11)}\n addUserKnob {7 convolve_scale l Scale t "+scaleZ+" R 0.01 3}\n convolve_scale 2\n addUserKnob {4 Choose_Shape l INVISIBLE t "+shapeZ+" +INVISIBLE M {A B C D E F G H I J K L "+nothZ+"}}\n addUserKnob {26 "+nothZ+"}\n addUserKnob {26 Bo_selec l "+nothZ+" +STARTLINE T "+glewZ+"}\n}\n Read {\n  inputs 0\n  file "+bokNet+"\n  format "+formZ+"\n  origset true\n  name Read144\n  xpos -920\n  ypos -603\n }\n"
  bokEndT = "\nShuffle {\n green red\n blue red\n alpha red\n name Shuffle2\n xpos -920\n ypos -475\n}\nset N62319400 [stack 0]\nDot {\n name Dot7\n xpos -886\n ypos -274\n}\nset N62319000 [stack 0]\nDot {\n name Dot12\n xpos -886\n ypos -118\n}\nDot {\n name Dot16\n xpos -996\n ypos -118\n}\nset N62318400 [stack 0]\nCrop {\n box {695.25 1 900.75 207}\n softness 14.5\n reformat true\n crop false\n name Crop13\n xpos -1030\n ypos -42\n}\npush $N62318400\nDot {\n name Dot15\n xpos -1104\n ypos -118\n}\nset Nbf54f000 [stack 0]\nCrop {\n box {465.25 0 670.75 206}\n softness 14.5\n reformat true\n name Crop12\n xpos -1138\n ypos -42\n}\npush $Nbf54f000\nDot {\n name Dot14\n xpos -1204\n ypos -118\n}\nset Nc2af2400 [stack 0]\nCrop {\n box {228.75 -0.5 434.25 205.5}\n softness 14.5\n reformat true\n name Crop11\n xpos -1238\n ypos -41\n}\npush $Nc2af2400\nDot {\n name Dot13\n xpos -1307\n ypos -118\n}\nCrop {\n box {-0.25 0 205.25 206}\n softness 14.5\n reformat true\n name Crop10\n xpos -1341\n ypos -43\n}\npush $N62319000\nDot {\n name Dot11\n xpos -1009\n ypos -274\n}\nset Nd4d03400 [stack 0]\nCrop {\n box {698.25 208 903.75 414}\n softness 14.5\n reformat true\n name Crop9\n xpos -1043\n ypos -179\n}\npush $Nd4d03400\nDot {\n name Dot10\n xpos -1104\n ypos -274\n}\nset Nc6fd0c00 [stack 0]\nCrop {\n box {467.25 208 672.75 414}\n softness 14.5\n reformat true\n crop false\n name Crop8\n xpos -1138\n ypos -180\n}\npush $Nc6fd0c00\nDot {\n name Dot9\n xpos -1205\n ypos -274\n}\nset Nc6fd0800 [stack 0]\nCrop {\n box {233.25 207 438.75 413}\n softness 14.5\n reformat true\n crop false\n name Crop7\n xpos -1239\n ypos -184\n}\npush $Nc6fd0800\nDot {\n name Dot8\n xpos -1306\n ypos -274\n}\nCrop {\n box {0.25 206 205.75 412}\n softness 14.5\n reformat true\n crop false\n name Crop6\n xpos -1340\n ypos -187\n}\npush $N62319400\nDot {\n name Dot6\n xpos -1011\n ypos -452\n}\nset Ne2d69c00 [stack 0]\nCrop {\n box {699.25 412 904.75 618}\n softness 14.5\n reformat true\n crop false\n name Crop5\n xpos -1045\n ypos -378\n}\npush $Ne2d69c00\nDot {\n name Dot5\n xpos -1107\n ypos -452\n}\nset Ne2d69000 [stack 0]\nCrop {\n box {464.25 412 669.75 618}\n softness 14.5\n reformat true\n crop false\n name Crop4\n xpos -1141\n ypos -377\n}\nDot {\n name Dot19\n xpos -1107\n ypos -326\n}\npush $Ne2d69000\nDot {\n name Dot4\n xpos -1206\n ypos -452\n}\nset Nc2b68000 [stack 0]\nCrop {\n box {232.25 412 437.75 618}\n softness 14.5\n reformat true\n crop false\n name Crop3\n xpos -1240\n ypos -377\n}\npush $Nc2b68000\nDot {\n name Dot3\n xpos -1307\n ypos -452\n}\nCrop {\n box {0 412 205.5 618}\n softness 14.5\n reformat true\n crop false\n name Crop2\n xpos -1341\n ypos -377\n}\nSwitch {\n inputs 12\n which {{Bokeh_Selecta.Choose_Shape}}\n name Switch1\n xpos -1581\n ypos -63\n}\nReformat {\n type scale\n scale {{parent.convolve_scale}}\n name Reformat3\n xpos -1581\n ypos 10\n}\nOutput {\n name Output1\n xpos -1581\n ypos 140\n}\nend_group\n"
  bokSelA = bokSel+bokEndT

  clipboard.setText(bokSelA)
  nuke.nodePaste("%clipboard%")

# bokehSelecta3()